<template>
	<div class="row d-flex align-items-center">
		<div class="col-6">
			<h3>
				Сотрудники
			</h3>
		</div>
		<div class="col-6 d-flex justify-content-end">
		    <a-button class="mr-3" @click="dep_showModal">Новый отдел</a-button>
		    <a-button @click="showModal">Новый сотрудник</a-button>
		</div>
		<div class="col-12 mt-3" v-for="department in departments" :key="department.id">
			<a-card :title="department.name">
				<div slot="extra">
					<a href="javascript:void(0);">Изменить</a>
				</div>
				<div class="row d-flex align-items-center mb-3 user-row" v-for="user in department.users" :key="user.id">
					<div class="col">
						<a href="javascript:void(0);">{{ user.position }}</a>
					</div>
					<div class="col">
						{{ user.full_name }}
					</div>
					<div class="col">
						{{ user.mob_phone }}
					</div>
					<div class="col">
						{{ user.email }}
					</div>
				</div>
		    </a-card>
		</div>

		<a-modal
	      v-model="dep_visible"
	      title="Добавить отдел"
	      onOk="handleOk"
	    >
	      <template slot="footer">
	        <a-button key="back" @click="dep_handleCancel">Отмена</a-button>
	        <a-button key="submit" type="primary" :loading="dep_loading" @click="dep_handleOk">
	          Отправить
	        </a-button>
	      </template>
	      <form>
	      	<div class="form-group">
	      		<a-input placeholder="Название" v-model="dep_add.name"/>
	      	</div>
	      	<div class="form-group">
	      		<a-textarea placeholder="Описание" :autosize="{ minRows: 6, maxRows: 30 }" v-model="dep_add.description"/>
	      	</div>
	      </form>
	    </a-modal>

		<a-modal
	      v-model="visible"
	      title="Добавить Сотрудника"
	      onOk="handleOk"
	    >
	      <template slot="footer">
	        <a-button key="back" @click="handleCancel">Отмена</a-button>
	        <a-button key="submit" type="primary" :loading="loading" @click="handleOk">
	          Отправить
	        </a-button>
	      </template>
	      <form>
	      	<div class="form-group">
	      		<a-select
				    showSearch
				    placeholder="Отдел"
				    optionFilterProp="children"
				    @change="handleChange"
				    :filterOption="filterOption"
				    >
				    <a-select-option v-for="department in departments" :key="department.id" :value="department.id">{{ department.name }}</a-select-option>
				</a-select>
	      	</div>
	      	<div class="form-group">
	      		<a-input placeholder="Фамилия" v-model="add.l_name"/>
	      	</div>
	      	<div class="form-group">
	      		<a-input placeholder="Имя" v-model="add.f_name"/>
	      	</div>
	      	<div class="form-group">
	      		<a-input placeholder="Отчество" v-model="add.m_name"/>
	      	</div>
	      	<div class="form-group">
	      		<a-input placeholder="Email" v-model="add.email"/>
	      	</div>
	      	<div class="form-group">
	      		<a-input placeholder="Мобильный телефон" v-model="add.mob_phone"/>
	      	</div>
	      	<div class="form-group">
	      		<a-input placeholder="Рабочий телефон" v-model="add.work_phone"/>
	      	</div>
	      	<div class="form-group">
	      		<a-input placeholder="Должность" v-model="add.position"/>
	      	</div>
	      	<div class="form-group">
	      		<a-input placeholder="Пароль" v-model="add.password"/>
	      	</div>
	      </form>
	    </a-modal>
	</div>
</template>

<script type="text/javascript">
	const columns = [{
	  title: 'Должность',
	  dataIndex: 'position',
	  scopedSlots: { customRender: 'name' },
	}, {
	  title: 'Ф.И.О.',
	  dataIndex: 'full_name',
	}, {
	  title: 'Email',
	  dataIndex: 'email',
	  scopedSlots: { customRender: 'email' },
	}];

	export default {
		data() {
			return {
				pagination: false,
				columns,
				departments: '',
				loading: false,
      			dep_loading: false,
      			visible: false,
      			dep_visible: false,
      			dep_add: {
      				name: '',
      				description: ''
      			},
      			add: {
      				f_name: '',
      				l_name: '',
      				m_name: '',
      				email: '',
      				mob_phone: '',
      				work_phone: '',
      				position: '',
      				department: '',
      				password: '',
      			}
			}
		},
		created() {
			this.loadData()
		},
		methods: {
			loadData() {
				this.$http.get('/api/v1/getAllUsers')
				.then(this.loadDataSuccess,this.loadDataError)
			},
			loadDataSuccess(res) {
				this.departments = res.body
			},
			loadDataError(err) {
				console.log(err)
			},	
			showModal() {
		      this.visible = true;
		    },
		    handleOk(e) {
		      this.loading = true;
		      this.addUser()
		    },
		    handleCancel(e) {
		      this.visible = false;
		    },
		    addUser() {
		    	if (this.add.department != '') {
		    		let data = {
		    			f_name: this.add.f_name,
		    			l_name: this.add.l_name,
		    			m_name: this.add.m_name,
		    			mob_phone: this.add.mob_phone,
		    			work_phone: this.add.work_phone,
		    			position: this.add.position,
		    			department: this.add.department,
		    			email: this.add.email,
		    			password: this.add.password,
		    		}
		    		this.$http.post('/api/v1/addUser', data)
		    		.then(this.addUserSuccess,this.addUserError)
		    	} else {
		    		this.$message.warning('Выберите отдел');
		    		this.loading = false;
		    	}
		    },
		    addUserSuccess(res) {
		    	this.$message.success('Сотрудник добавлен');
		    	this.loadData();
		    	this.loading = false;
		    	this.visible= false;
		    	this.f_name = '';
      			this.l_name = '';
      			this.m_name = '';
      			this.email = '';
      			this.mob_phone = '';
      			this.work_phone = '';
      			this.position = '';
      			this.department = '';
      			this.password = '';
		    },
		    addUserError(err) {
		    	if (err.status === 422) {
		    		this.$message.error('Сотрудник с таким email уже существует');
		    	}
		    	this.loading = false;
		    },
		    filterOption(input, option) {
		      return option.componentOptions.children[0].text.toLowerCase().indexOf(input.toLowerCase()) >= 0
		    },
		    handleChange (value) {
		      this.add.department = value
		    },
		    dep_showModal() {
		      this.dep_visible = true;
		    },
		    dep_handleOk(e) {
		      this.dep_loading = true;
		      this.addDepartment()
		    },
		    dep_handleCancel(e) {
		      this.dep_visible = false;
		    },
		    addDepartment() {
		    	let params = {
		    		name: this.dep_add.name,
		    		description: this.dep_add.description
		    	}
		    	this.$http.post('/api/v1/addDepartment', params)
		    	.then(this.addDepartmentSuccess,this.addDepartmentError)
		    },
		    addDepartmentSuccess(res) {
		    	this.$message.success('Отдел добавлен');
		    	this.loadData()
		    	this.dep_add.name = ''
		    	this.dep_add.description = ''
		    	this.dep_visible = false
		    	this.dep_loading = false
		    },
		    addDepartmentError(err) {
		    	if (err.status === 422) {
		    		this.dep_loading = false
		    		this.$message.error('Этот отдел уже существует');
		    	}
		    },
		    deleteDepartment(id, count) {
		    	if (count > 0) {
		    		this.$notification['error']({
			          message: 'Ошибка',
			          description: 'Нельзя удалить отдел с сотрудниками!',
			        });
		    	}
		    }
		}
	}
</script>